/**********************************************************************************************/
/* FBL_SumFormula.h																			  */
/*                                                                       					  */
/* Foundation Base Library ( FBL )		                                   					  */
/*                                                                       					  */
/* Copyright Paradigma, 1993-2002                                       					  */
/* All Rights Reserved.                                                 					  */
/**********************************************************************************************/

#ifndef __FBL_SumFormula_h
   #define __FBL_SumFormula_h

#if VSDK_FRAMEWORK_STYLE
#	include <VSDK/FBL_Formula.h>
#else
#	include <FBL_Formula.h>
#endif // VSDK_FRAMEWORK_STYLE

#if defined(__MWERKS__)
	#pragma options align=power
#endif


/**********************************************************************************************/
class FBL_SumFormula : public FBL_ConstFormula
{
		// must be applied for numeric fields only.

	public://///////////////////////////////////////////////////////////////////////////////////

FBL_EXP						FBL_SumFormula( uchar inFieldType );
							
FBL_EXP virtual bool		DoFormula( 
								FBL_REC_ID	inRecID,
								const void* inFieldValue,
								bool		inIsNull );
					
		double				GetResult( void ) const { return mTotal; }			
						
	protected:////////////////////////////////////////////////////////////////////////////////// 
	
		uchar		mFieldType;
		double		mTotal;				
};


/**********************************************************************************************/
#if defined(__MWERKS__)
	#pragma options align=reset
#endif

#endif
