/**********************************************************************************************/
/* FBL_SynObjectsNative.h																	  */
/*                                                                       					  */
/* Foundation Base Library ( FBL )		                                   					  */
/*                                                                       					  */
/* Copyright Paradigma, 1993-2002															  */
/* All Rights Reserved.                                                 					  */
/**********************************************************************************************/
 
#ifndef __FBL_SynObjectsNative_h
	#define __FBL_SynObjectsNative_h

#if VSDK_FRAMEWORK_STYLE
#	include <VSDK/FBL.h>
#else
#	include <FBL.h>
#endif // VSDK_FRAMEWORK_STYLE

#include <limits.h>

#if defined(__MWERKS__)
	#pragma options align=power
#endif


/**********************************************************************************************/
class FBL_MutexNative;
class FBL_SemaphoreNative;


/**********************************************************************************************/
FBL_MutexNative* 		FBL_CreateMutex( bool inLocked );
FBL_SemaphoreNative* 	FBL_CreateSemaphore( ulong inCount );


/**********************************************************************************************/
class FBL_SyncObjectNative 
{
	public://///////////////////////////////////////////////////////////////////////////////////
	 
								FBL_SyncObjectNative( void ) 	{}
virtual 						~FBL_SyncObjectNative( void ) 	{}
						
virtual bool 					Lock( long inTimeout = LONG_MAX ) 	= 0;
virtual	void 					Unlock( void ) 						= 0;

};


/**********************************************************************************************/
class FBL_MutexNative : public FBL_SyncObjectNative 
{
	public://///////////////////////////////////////////////////////////////////////////////////

  								FBL_MutexNative( bool /*inLocked*/ = false ) {}

virtual bool 					Lock( long inTimeout = LONG_MAX ) 	= 0;
virtual	void 					Unlock( void ) 						= 0;

};


/**********************************************************************************************/
class FBL_SemaphoreNative : public FBL_SyncObjectNative 
{
	public://///////////////////////////////////////////////////////////////////////////////////

  								FBL_SemaphoreNative( ulong inCount ) {
  									argused1(inCount);
  								}
  								  						
virtual bool 					Lock( long inTimeout = LONG_MAX ) 	= 0;
virtual	void 					Unlock( void ) 						= 0;

};


/**********************************************************************************************/
#if defined(__MWERKS__)
	#pragma options align=reset
#endif

#endif // __FBL_SynObjectsNative_h